from typing import Literal

from nexuslabdata.utils import NldStrEnum


class FlowIncrementalType(NldStrEnum):
    FULL = "FULL"
    ON_SOURCE_TECHNICAL_TST = "ON_SOURCE_TECHNICAL_TST"
    ON_SOURCE_TECHNICAL_TST_FIXED_SELECTION_RANGE = (
        "ON_SOURCE_TECHNICAL_TST_FIXED_SELECTION_RANGE"
    )
    ON_TARGET_FUNCTIONAL_KEY = "ON_TARGET_FUNCTIONAL_KEY"
    ON_TARGET_FUNCTIONAL_KEY_BASED_ON_SOURCE_TST = (
        "ON_TARGET_FUNCTIONAL_KEY_BASED_ON_SOURCE_TST"
    )
    ON_TARGET_FUNCTIONAL_DATE_RANGE_BASED_ON_SOURCE_TST = (
        "ON_TARGET_FUNCTIONAL_DATE_RANGE_BASED_ON_SOURCE_TST"
    )
    ON_TARGET_FUNCTIONAL_MONTH_RANGE_BASED_ON_SOURCE_TST = (
        "ON_TARGET_FUNCTIONAL_MONTH_RANGE_BASED_ON_SOURCE_TST"
    )


FLOW_INCREMENTAL_TYPE_LITERAL = Literal[
    "FULL",
    "ON_SOURCE_TECHNICAL_TST",
    "ON_SOURCE_TECHNICAL_TST_FIXED_SELECTION_RANGE",
    "ON_TARGET_FUNCTIONAL_KEY",
    "ON_TARGET_FUNCTIONAL_KEY_BASED_ON_SOURCE_TST",
    "ON_TARGET_FUNCTIONAL_DATE_RANGE_BASED_ON_SOURCE_TST",
    "ON_TARGET_FUNCTIONAL_MONTH_RANGE_BASED_ON_SOURCE_TST",
]


class FlowIncrementalPeriodRangeType(NldStrEnum):
    HOURS = "HOURS"
    DAYS = "DAYS"
    MONTHS = "MONTHS"
    YEARS = "YEARS"
    FIXED_DAYS = "FIXED_DAYS"


FLOW_INCREMENTAL_PERIOD_RANGE_TYPE_LITERAL = Literal[
    "HOURS", "DAYS", "MONTHS", "YEARS", "FIXED_DAYS"
]
